<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/peruse_crossref.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p2 { color: #ffffe0; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
.textRainbow_lv0_p1 { color: #add8e6; }
.textRainbow_lv0_p2 { color: #add8e6; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr"> 1 </span>02/18/85  peruse_crossref, pcref
<span id="L2" class="LineNr"> 2 </span>
<span id="L3" class="LineNr"> 3 </span>Syntax as a command:  pcref <span class="textRainbow_lv0_p2">{</span>cref_path<span class="textRainbow_lv0_p2">}</span> search_names <span class="textRainbow_lv0_p2">{</span>-control_args<span class="textRainbow_lv0_p2">}</span>
<span id="L4" class="LineNr"> 4 </span>
<span id="L5" class="LineNr"> 5 </span>
<span id="L6" class="LineNr"> 6 </span>Syntax as an active function:  <span class="textRainbow_lv0_p1">[</span>pcref <span class="textRainbow_lv1_p2">{</span>cref_path<span class="textRainbow_lv1_p2">}</span> search_names<span class="textRainbow_lv0_p1">]</span>
<span id="L7" class="LineNr"> 7 </span>
<span id="L8" class="LineNr"> 8 </span>
<span id="L9" class="LineNr"> 9 </span>Function: prints or returns information extracted from the output file
<span id="L10" class="LineNr">10 </span>generated by the cross_reference command.
<span id="L11" class="LineNr">11 </span>
<span id="L12" class="LineNr">12 </span>
<span id="L13" class="LineNr">13 </span>Arguments:
<span id="L14" class="LineNr">14 </span>cref_path
<span id="L15" class="LineNr">15 </span>   is the pathname of the crossref output file to search.  It can be a
<span id="L16" class="LineNr">16 </span>   multisegment file <span class="textRainbow_lv0_p0">(</span>MSF<span class="textRainbow_lv0_p0">)</span>.  It must contain a &gt; or &lt; character to
<span id="L17" class="LineNr">17 </span>   distinguish it from a search_name.  If you supply no cref_path, the
<span id="L18" class="LineNr">18 </span>   total system cross-reference <span class="textRainbow_lv0_p0">(</span>&gt;ldd&gt;crossref&gt;total.crossref<span class="textRainbow_lv0_p0">)</span> is used.
<span id="L19" class="LineNr">19 </span>   To specify a cross-reference in your working directory, use
<span id="L20" class="LineNr">20 </span>   -pathname.
<span id="L21" class="LineNr">21 </span>search_names
<span id="L22" class="LineNr">22 </span>   are one or more names to search for references to in the crossref.
<span id="L23" class="LineNr">23 </span>   They can be either symbolic linker references or include file names
<span id="L24" class="LineNr">24 </span>   and can have any of the following forms:
<span id="L25" class="LineNr">25 </span>      segname
<span id="L26" class="LineNr">26 </span>      segname$entryname
<span id="L27" class="LineNr">27 </span>      XXX.incl.YYY
<span id="L28" class="LineNr">28 </span>
<span id="L29" class="LineNr">29 </span>
<span id="L30" class="LineNr">30 </span>   Any component of a search name can be a star name, except that
<span id="L31" class="LineNr">31 </span>   neither a segname nor an include file name can begin with a star
<span id="L32" class="LineNr">32 </span>   name character and the string &quot;.incl&quot; must appear in toto.  If you
<span id="L33" class="LineNr">33 </span>   specify no entryname with the segname, all references to any entry
<span id="L34" class="LineNr">34 </span>   points in the segment are listed.  XXX.incl is accepted as an
<span id="L35" class="LineNr">35 </span>   abbreviation for XXX.incl.*.  Don't use &gt; and &lt; in a search name.
<span id="L36" class="LineNr">36 </span>
<span id="L37" class="LineNr">37 </span>
<span id="L38" class="LineNr">38 </span>Control arguments:
<span id="L39" class="LineNr">39 </span>-brief, -bf
<span id="L40" class="LineNr">40 </span>   does not print any information for selected cross-reference items
<span id="L41" class="LineNr">41 </span>   that have no entries <span class="textRainbow_lv0_p0">(</span>callers<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Default<span class="textRainbow_lv0_p0">)</span>
<span id="L42" class="LineNr">42 </span>-brief_errors, -bfe
<span id="L43" class="LineNr">43 </span>   suppreses any error messages due to entrypoints or include files
<span id="L44" class="LineNr">44 </span>   that are not found in the crossref.
<span id="L45" class="LineNr">45 </span>-long, -lg
<span id="L46" class="LineNr">46 </span>   print selected cross-reference items that have no entries.
<span id="L47" class="LineNr">47 </span>-long_errors, -lge
<span id="L48" class="LineNr">48 </span>   prints an error message if one or more entrypoints or include files
<span id="L49" class="LineNr">49 </span>   given on the command line are not found in the crossref.  <span class="textRainbow_lv0_p0">(</span>Default<span class="textRainbow_lv0_p0">)</span>
<span id="L50" class="LineNr">50 </span>-pathname crossref path, -pn crossref path
<span id="L51" class="LineNr">51 </span>   specifies crossref path as the crossref to search.
<span id="L52" class="LineNr">52 </span>
<span id="L53" class="LineNr">53 </span>
<span id="L54" class="LineNr">54 </span>Notes: This command uses a binary search to locate the desired
<span id="L55" class="LineNr">55 </span>information and thus is quite inexpensive, even when searching the
<span id="L56" class="LineNr">56 </span>total system crossref.  Average cost for a single search of the system
<span id="L57" class="LineNr">57 </span>crossref is about 45 page faults and 0.5 CPU seconds, or roughly 30
<span id="L58" class="LineNr">58 </span>times cheaper and far more convenient than using an editor.
<span id="L59" class="LineNr">59 </span>
<span id="L60" class="LineNr">60 </span>No attempt is made to combine the results of the search names--if you
<span id="L61" class="LineNr">61 </span>ask for something twice, it gets printed twice.
<span id="L62" class="LineNr">62 </span>
<span id="L63" class="LineNr">63 </span>This command does not perform any significant validation on the input
<span id="L64" class="LineNr">64 </span>filen and is likely to either take faults or signal the logic_error
<span id="L65" class="LineNr">65 </span>condition if asked to search something other than a crossref output
<span id="L66" class="LineNr">66 </span>file.
<span id="L67" class="LineNr">67 </span>
<span id="L68" class="LineNr">68 </span>
<span id="L69" class="LineNr">69 </span>There is no support for synonyms--a search name must be the primary
<span id="L70" class="LineNr">70 </span>name of a segment and not a synonym established in a bindfile or the
<span id="L71" class="LineNr">71 </span>hardcore header.
<span id="L72" class="LineNr">72 </span>
<span id="L73" class="LineNr">73 </span>There is no way to select specific types of things, such as all the
<span id="L74" class="LineNr">74 </span>unresolvable references in the crossref.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
